//+------------------------------------------------------------------+
//|                                                  iLeprechaun.mq4 |
//|                                                   Maksym Stukalo |
//|                                         stukalo.maksym@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Maksym Stukalo"
#property link      "stukalo.maksym@gmail.com"
#property version   "1.00"
#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#include "mql4-mysql.mqh"
#include <stderror.mqh>
#include <stdlib.mqh>

input int					order_ticket;
input string				db_name;
input int					CGraphUpdate = 15;
input int					OrderID;
//input int					chart_id;


double ExtBufferLine0[];
double ExtBufferLine1[];
double ExtBufferLine2[];
double ExtBufferLine3[];
double ExtBufferLine4[];

class CMySQL
{
	public:
	
	string query;
	string  hosts;
	string  user;
	string  pass;
	string  dbName;
	
	int     port;
	int     socket;
	int     client;

	int     dbConnectId;
	
	
	void CMySQL()
	{
		hosts		= "127.0.0.1";
		user   	    = "root";
		pass   	    = "1234567809";
		dbName      = db_name;
		port     	= 3306;
		socket   	= 0;
		client   	= 0;
		dbConnectId = 0;
		
		if(!init_MySQL(dbConnectId, hosts, user, pass, dbName, port, socket, client)){
			Print("Cann't connect to the database:",MySQL_NoError(dbConnectId));
		}else
			Print("iLeprechaun connercted to db seccesfully");		
	}
	int getTableLen()
	{
		Print("5");
		query = StringConcatenate("SELECT * FROM _",order_ticket,";");
		Print("6");
		return MySQL_Num_Rows(dbConnectId,query);
	}
	int getRowValue(string row_name, int inc)
	{
		query = StringConcatenate("SELECT '",row_name,"' FROM _",order_ticket," WHERE inc = ",inc,";");
		string arr[1][1];
		int res = MySQL_FetchArray(dbConnectId, query, arr);
		if(!res)
			Print("cann't getRowValue:",MySQL_NoError(dbConnectId));	
		
		return StrToInteger(arr[0][0]);
	}

};

CMySQL db;

class iIndicator
{
	public:
	
	string createObjName()
	{
		return StringConcatenate(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),IntegerToString(MathRand(),5));
	}
};
iIndicator ind;

class iLeprechaun
{
	public:
	
	int lenOfFields;
	
	iLeprechaun()
	{
		string indicator_name	= ind.createObjName();
		IndicatorShortName(indicator_name);
		IndicatorDigits(2);
		SetIndexStyle(0,2,0,2,Gold);  
		
		SetIndexStyle(1,2,0,2,Gold);		

		SetIndexStyle(2,2,0,2,Gold);
		
		SetIndexStyle(3,2,0,2,Gold);
		
		SetIndexStyle(4,2,0,2,Gold);
		
		lenOfFields = 0;
	}
	void updateLines()
	{  
		ExtBufferLine0[ilep.lenOfFields] = db.getRowValue(StringConcatenate("diff0"), lenOfFields);
		ExtBufferLine1[ilep.lenOfFields] = db.getRowValue(StringConcatenate("diff1"), lenOfFields);
		ExtBufferLine2[ilep.lenOfFields] = db.getRowValue(StringConcatenate("diff2"), lenOfFields);
		ExtBufferLine3[ilep.lenOfFields] = db.getRowValue(StringConcatenate("diff3"), lenOfFields);		
		ExtBufferLine4[ilep.lenOfFields] = db.getRowValue(StringConcatenate("avar") , lenOfFields);	
	}
};

iLeprechaun ilep;

int OnInit()
  {
	Print("1");
	IndicatorBuffers(5);
	Print("2");
	ilep.lenOfFields = db.getTableLen();	
	Print("3");
	SetIndexBuffer(0, ExtBufferLine0);
	SetIndexBuffer(1, ExtBufferLine1);
	SetIndexBuffer(2, ExtBufferLine2);
	SetIndexBuffer(3, ExtBufferLine3);
	SetIndexBuffer(4, ExtBufferLine4);

  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
	  Print("9");
	if(db.getTableLen() != ilep.lenOfFields){
		ilep.lenOfFields++;
		ilep.updateLines();
		Print("10");
	}	
   return(rates_total);
  }

//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
  }
//+------------------------------------------------------------------+
